<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Ajax Axios</title>
</head>
<body>
    <div id="app">
        <form action="">
            <table>
                <tr>
                    <td><label for="name">Name</label></td>
                    <td>:</td>
                    <td><input type="text" name="name" ref="name" v-model="newMember.name" :disabled="formType === 'upload'"></td><br>
                </tr>

                <tr>
                    <td><label for="address">Address</label></td>
                    <td>:</td>
                    <td><input type="text" name="address" ref="address" v-model="newMember.address" :disabled="formType === 'upload'"></td><br>
                </tr>

                <tr>
                    <td><label for="hp">No HP</label></td>
                    <td>:</td>
                    <td><input type="text" name="no_hp" ref="no_hp" v-model="newMember.no_hp" :disabled="formType === 'upload'"></td><br>
                </tr>

                <tr>
                    <td><input type="file" name="foto" ref="foto" v-if="formType === 'upload'"></td>
                </tr>

                <tr>
                    <td><input type="submit" value="Submit" v-if="formType === 'add'" @click.prevent="addMember()"></td>
                </tr>

                <tr>
                    <td><input type="submit" value="Update" v-if="formType === 'update'" @click.prevent="editMember()"></td>
                </tr>

                <tr>
                    <td><input type="submit" value="Upload" v-if="formType === 'upload'" @click.prevent="uploadPhoto()"></td>
                </tr>

                <tr>
                    <td><input type="submit" value="Cancel" v-if="formType === 'update' || formType === 'upload'" @click.prevent="removeForm()"></td>
                </tr>
            </table>
        </form>

        <table border="1">
            <tr v-for="member in members">
                <td><img width="100" :src="member.photo_profile ? url + member.photo_profile : 'https://dummyimage.com/16:9x1080'" alt="Photo"></td>
                <td style="width: 400px">
                    <h2>Name: {{member.name}}</h2>
                    <h3>Address: {{member.address}}</h3>
                    <h3>Nomor Handphone: {{member.no_hp}}</h3>
                </td>

                <td>
                    <button @click.prevent="click(member, 'update')">Edit</button>
                    <button @click.prevent="deleteMember(member.id)">Delete</button>
                    <button @click.prevent="click(member, 'upload')">Upload Foto</button>
                </td>
            </tr>
        </table>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
    <script>
        var vm = new Vue({
            el: '#app',
            data: {
                url: 'https://demo-api-vue.sanbercloud.com/',
                formType: 'add',
                members: [],
                errors: [],
                id: null,
                newMember: {
                    name: '',
                    address: '',
                    no_hp: ''
                },
            },
            methods : {
                removeForm(){
                    this.newMember = {}
                    this.id = null,
                    this.formType = 'add'
                },
                click(member, type){
                    this.formType = type
                    this.id = member.id
                    this.newMember = {
                        name: member.name,
                        address: member.address,
                        no_hp: member.no_hp
                    }
                },
                async fetchMember(){
                    try{
                        const {data} = await axios.get(`${this.url}api/member`)
                        this.members = data.members
                    } catch(err){
                        console.log(err)
                    }
                },
                async addMember(){
                    try{
                        const hasil = await axios.post(`${this.url}api/member`, this.newMember)
                        console.log(hasil)
                        this.removeForm()
                        this.fetchMember()
                        alert(`Berhasil menambahkan data`)
                    } catch(err){
                        console.log(err)
                    }
                },
                async editMember(){
                    try{
                        const update = await axios.post(`${this.url}api/member/${this.id}?_method=PUT`, this.newMember)
                        console.log(update)
                        this.removeForm()
                        this.fetchMember()
                        alert(`Berhasil edit data`)
                    } catch(err){
                        console.log(err)
                    }
                },
                async deleteMember(id){
                    try{
                        const hapus = await axios.post(`${this.url}api/member/${id}?_method=DELETE`)
                        console.log(hapus)
                        this.fetchMember()
                        alert(`Berhasil menghapus data ${id}`)
                    } catch(err){
                        console.log(err)
                    }
                },
                async uploadPhoto(){
                    try{
                        const photo_profile = this.$refs.photo.files[0]
                        const formData = new FormData()
                        formData.set('foto profil', photo_profile)

                        const upload = await axios.post(`${this.url}api/member/${this.id}/upload-photo-profile`, formData)
                        this.removeForm()
                        this.fetchMember()
                        alert('Berhasil menambahkan foto')
                    } catch (err){
                        console.log(err)
                    }
                }
            },
            created(){
                this.fetchMember()
            }
        })
    </script>
</body>
</html>